#!/bin/bash
#
# Copyright (C) 2017 Free Software Foundation, Inc.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation; either version 2.1 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

#debug output , set 0 or 1=debug
v=0

#ssl-cert-check requires at least version 3.29-1
minversion=3.29-1

if [ ! -d /etc/dehydrated/certs ]; then exit 1 ; fi
if [ ! -x /usr/bin/which    ] ; then exit 2; fi
if ! which ssl-cert-check  >/dev/null 2>&1; then exit 3; fi
if ! which gawk            >/dev/null 2>&1; then exit 4; fi
if ! which ssl-cert-check  >/dev/null 2>&1; then exit 5; fi
installversion=$(dpkg -l ssl-cert-check | awk '$2=="ssl-cert-check" { print $3 }')
if [ $v == 1 ]; then echo "installversion $installversion" ; fi
if dpkg --compare-versions $installversion lt $minversion
	then if [ $v == 1 ]; then echo "Version ssl-cert-check too old" ; exit 7 ; fi
fi

cd /etc/dehydrated/certs/
for DOMAIN in * ; do
	error=0; trap 'error=$(($?>$error?$?:$error))' ERR
	if [ $v == 1 ]; then echo "DOMAIN $DOMAIN" ; fi
	state=$( ssl-cert-check -b -n -s ${DOMAIN} -p 443 -x 20 -v -tls1_2)
	if [ $v == 1 ]; then echo "state $state" ; fi
	formattedstate=$(gawk '{print "Certificate_" $1 " - " $2,$3,$4,$5,$6 }' <<<$state )
	if [ $DOMAIN == "*" ]; then exit 8; fi
	echo ${error} ${formattedstate}
done

